/*
 *  funciones.c
 *  Listas
 *
 *  Created by coti on 11/12/09.
 *  Copyright 2009 __MyCompanyName__. All rights reserved.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "funciones.h"

void iniciacion(GlobalRef p){
	p->ppio = p->fin = NULL;
}

void conclusion(GlobalRef p){
	vaciar(p);
	p->ppio = p->fin = NULL;
}

void anadirPpio(GlobalRef p){
	NodoRef temp = malloc(sizeof(Nodo));
	printf("\n\n");
	rellenarNodo(temp);temp->sig = NULL;
	if (NULL == p->ppio) {
		p->ppio = p->fin = temp;
	} else {
		temp->sig = p->ppio;
		p->ppio = temp;
	}
}

void anadirFinal(GlobalRef p){
	NodoRef temp = malloc(sizeof(Nodo));
	printf("\n\n");
	rellenarNodo(temp);temp->sig = NULL;
	if (NULL == p->ppio) {
		p->ppio = p->fin = temp;
	} else {
		p->fin->sig = temp;
		p->fin = temp;
	}

}
void anadirPpioNodoDado(GlobalRef p, NodoRef temp){
	if (NULL == p->ppio) {
		p->ppio = p->fin = temp;
	} else {
		temp->sig = p->ppio;
		p->ppio = temp;
	}
}

void anadirFinalNodoDado(GlobalRef p, NodoRef temp){
	if (NULL == p->ppio) {
		p->ppio = p->fin = temp;
	} else {
		p->fin->sig = temp;
		p->fin = temp;
	}

}

NodoRef eliminarPrincipio(GlobalRef p){
	NodoRef temp = p->ppio;
	if (NULL != p->ppio) {
		if (NULL == p->ppio->sig) {
			p->ppio = p->fin = NULL;
		} else {
			p->ppio = p->ppio->sig;
		}
	}
	return temp;
}

NodoRef eliminarFinal(GlobalRef p){
	NodoRef temp = p->fin;
	NodoRef penultimo;
	if (NULL != p->ppio) {
		if (NULL == p->ppio->sig) {
			p->ppio = p->fin = NULL;
		} else {
			penultimo = p->ppio;
			while (penultimo->sig != p->fin) {
				penultimo = penultimo->sig;
			}
			p->fin = penultimo;
			p->fin->sig =NULL;
		}
	}
	return temp;
}

void insertarOrdenadoNombre(GlobalRef p){
	NodoRef temp = malloc(sizeof(Nodo));
	NodoRef ant, pos;
	printf("\n\n");
	rellenarNodo(temp);temp->sig = NULL;
	if (NULL == p->ppio) {
		p->ppio = p->fin = temp;
	} else {
		if (strcmp(temp->nombre, p->ppio->nombre)<=0) {
			anadirPpioNodoDado(p, temp);
		} else {
			if (strcmp(temp->nombre, p->fin->nombre)>=0) {
				anadirFinalNodoDado(p, temp);
			} else { // El nodo debe ocupar una posicin intermedia
				ant = p->ppio;
				pos = p->ppio->sig;
				while (!(strcmp(ant->nombre,temp->nombre)<=0 && strcmp(temp->nombre,pos->nombre)<=0)) {
					ant = pos;
					pos = pos->sig;
				}
				temp->sig = pos;
				ant->sig = temp;
			}
		}
	}
}

NodoRef eliminarOrdenadoNombre(GlobalRef p){
	NodoRef eliminado = NULL;
	NodoRef indice = NULL;
	char * nombreBuscado = pedir("\n\nEscriba el nombre que desea eliminar");
	int estaEnLaLista = 0;
	for(indice=p->ppio;indice != NULL;indice = indice->sig){
		if (strcmp(nombreBuscado, indice->nombre)==0) {
			eliminado = indice;
			estaEnLaLista = 1;
			break;
		}
	}
	if (!estaEnLaLista){
		printf("\n\nEse elemento no est en la lista\n\n");
	}
	else {
		if (p->ppio == eliminado) {
			eliminado = eliminarPrincipio(p);
		} else if (p->fin == eliminado) {
			eliminado = eliminarFinal(p);
		} else {
			for (indice=p->ppio; indice != NULL; indice = indice->sig) {
				if (indice->sig == eliminado) {
					break;
				}
			}
			// indice contiene la direccin del nodo anterior a temp
			indice->sig = eliminado->sig;
		}
	}
	return eliminado;
}

void listado(GlobalRef p){
	NodoRef temp;
	if (NULL == p->ppio)
		printf("\n\nLa lista est vaca.");
	printf("\n\n");
	for (temp=p->ppio; temp!= NULL; temp = temp->sig) {
		escribirPantalla(temp);
	}
}

void vaciar(GlobalRef p){
	NodoRef temp;
	do {
		temp = eliminarPrincipio(p);
		free(temp);
	} while (NULL != temp);
	printf("\n\nSe ha vaciado la lista.\n\n");
}

void rellenarNodo(NodoRef p){
	strcpy(p->nombre,pedir("Deme el nombre: "));
	p->talla =    pedirFloat("Escriba el peso: ", 35.0, 120.0);
	p->telefono = pedirInt(  "Escriba el telefono: ", 923000000, 923999999);
	p->sig = NULL;
}

void escribirPantalla(NodoRef p){
	printf("%20s %10d %6.2f %p\n",
		   p->nombre,
		   p->telefono,
		   p->talla,
		   p->sig);
}
